'use strict';

// ** Dependencies
const EventEmitter3 = require('eventemitter3');
const Arguments = require('./functions').Arguments;

class EventEmitter extends EventEmitter3 {
    constructor(options) {
        super();

        this._all = [];
    }

    onAny(handler) {
        this._all.push(handler);

        return this;
    }

    emit() {

        // Notify "onAny" subscribers
        if (this._all.length > 0) {
            const args = Arguments(arguments);
            const event = args.shift();

            // Call the handler: function(event, data)
            this._all.forEach(handler => handler.call(this, event, args));
        }

        // Notify "on" subscribers
        super.emit.apply(this, arguments);
    }
}

// ** Exports
module.exports = EventEmitter;
module.exports.EventEmitter = EventEmitter;