'use strict';

// ** Dependencies
const _ = require('lodash');
const Path = require('path');
const fs = require('fs-extra');

const files = dir => fs
    .readdir(dir)
    .then(files => files.map(file => Path
        .relative(process.cwd(), Path.join(dir, file))));

const requireDir = dir => files(dir)
    .then(files => files.map(filepath => {

        const filename = Path.parse(filepath).name;
        return [`  ${filename}`, ` require('./${filepath}')`].join(':');
    }))
    .then(modules => modules.join(',\n'))
    .then(modules => `module.exports = {\n${modules}\n};`);

// ** Exports
module.exports = requireDir;